package hSPEA2;

import java.util.Comparator;

public class Surgery {
	
	//int specialty;
	int surgery_id;
	int surgeon;
	int day;
	int room;
	Double scheduled_start_time;
	double scheduled_end_time;
	Duration duration;
	//double realized_duration;
	double realized_start_time;
	double realized_end_time;
	boolean included;
	
	public Surgery(int id, int k, int d, int r, double start, double end, Duration dr){
		//specialty = s;
		surgery_id = id;
		surgeon = k;
		day = d;
		room = r;
		scheduled_start_time = start;
		scheduled_end_time = end;
		duration = dr;
	}
	
	public void include(){
		included = true;
	}
	
	//public void set_realized_duration(double d){
	//	realized_duration = d;
	//}
	
	public void set_scheduled_start_time(double t){
		scheduled_start_time = t;
	}
	
	public void set_scheduled_end_time(double t){
		scheduled_end_time = t;
	}
	
	public void set_realized_start_time(double t){
		realized_start_time = t;
	}
	
	public void set_realized_end_time(double t){
		realized_end_time = t;
	}
	
	public void print_surgery_details(){
		System.out.println(surgery_id+", day "+day+", OR "+room+", "+"surgeon "+surgeon+": "+String.format("%.3g", scheduled_start_time)+" -> "+String.format("%.3g", scheduled_end_time));
	}
	
	public static Comparator<Surgery> COMPARE_BY_STARTING_TIME = new Comparator<Surgery>() {
        public int compare(Surgery one, Surgery other) {
            return one.scheduled_start_time.compareTo(other.scheduled_start_time);
        }
    };
}
